/*****************************************************************************
|*
|*  File:           mem.h
|*
|*  Version:    1.4
|* 
|*  Copyright 2001-2002 Altium BV
|*
 ****************************************************************************/

#ifndef _MEM_H
#define _MEM_H
#include "pcm51cc01.h"
void me_memory(char cmdindex);
void me_write_acc(unsigned char value);
void me_write_sfr(unsigned char address, unsigned char value);
unsigned char me_read_sfr(unsigned char address);


/*****************************************************************************
|*  FUNCTIONS:         me_write_*  me_read_*
|*  DESCRIPTION:       several functions to read or write a byte from/into a specific memory space
 */
_inline void
me_write_data(unsigned char address, unsigned char value)
{
    *(_data unsigned char *)address = value;
}

_inline void
me_write_xdat(unsigned int address, unsigned char value)
{
    *(_xdat unsigned char *)address = value;
}

/*
 *  write a byte into CODE memory. Since the 8051 architecture has no
 *  instruction to write into CODE memory the only way to write to it
 *  is to map (part of) the external XDATA bus to the CODE bus and then
 *  perform a write to the mapped XDATA address.
 */
_inline void
me_write_code(unsigned int address, unsigned char value)
{
# ifdef HAS_AUXRAM
#  ifdef SIZE_OF_AUXRAM/* =GM= */
    if (address < SIZE_OF_AUXRAM )
#  else
    if (address < 0x100)
#  endif
    {
        ta_write_auxcode(address, value);
        return;
    }
# endif
    *(_xdat unsigned char *)address = value;
}

_inline unsigned char
me_read_xdat(unsigned int address)
{
    return *(_xdat unsigned char *)address;
}

_inline unsigned char
me_read_data(unsigned char address)
{
    return *(_data unsigned char *)address;
}
_inline unsigned char
me_read_code(unsigned int address)
{
    return *(_rom unsigned char *)address;
}

#endif /* _MEM_H */
